clc
clear all;
close all;
disp('Refer Example 3.1');
%Effects of sampling on response
%Analog system
G=tf(1,[1 1 0]);
M=feedback(G,1);
%Transient response
figure(1)
step(M);
%Steady-state response
Kp=dcgain(G)
Gv=tf([1 0],1)*G;
Kv=dcgain(Gv)
Ga=tf([1 0],1)*Gv;
Ka=dcgain(Ga)
hold on;
%Sampled system
Ts=input('Enter the sampling time: ');
Gz=c2d(G,Ts);
Mz=feedback(Gz,1);
%Transient response
step(Mz);
%Steady-state response
Kpz=dcgain(Gz)
Gvz=tf([1 -1],1,Ts)*Gz/Ts;
Kvz=dcgain(Gvz)
Gaz=tf([1 -1],1,Ts)*Gvz/Ts;
Kaz=dcgain(Gaz)
hold off;
%Delay approximation of ZOH
%Refer Example 2.17
figure(2);
step(M);
hold on;
Gd=tf(1,[1 1 0],'InputDelay',Ts/2);
Gd1=pade(Gd,2);
M1=feedback(Gd1,1);
step(M1);
hold off;
%Using GUI, determine peak overshoot
%and settling time of analog and sampled system
