clc
clear all;
close all;
disp('Refer Example 7.7');
%Observer-based Regulator for Satellite Altitude Control
%Plant model
A=[0 1; 0 0]; b=[0;1];c=[1 0];
%Regulator Design
polesCL=[-4+4i,-4-4i];
k=place(A,b,polesCL)
Regulatorpoles=eig(A-b*k)
sys=ss(A-b*k,[0;0],c,0);
%Simulation
t=[0:0.01:1];
x0=[1 0]';
[y, t, X]=initial(sys,x0,t);
figure(1)
plot(t,y);
hold on
%Observer Design
polesOB=[-10 -10];
kk=acker(A',c',polesOB);
m=kk'
Observerpoles=eig(A-m*c)
%Refer Eqns.(7.58)&(7.59)
sys_comp=ss(A-b*k-m*c,m,k,0);
D=tf(sys_comp)
%Simulation
%Refer Eqn.(7.57)
A1=A-b*k;A2=b*k;A3=zeros(size(A));A4=A-m*c;
A_cl=[A1(1,:),A2(1,:);A1(2,:),A2(2,:);A3(1,:),A4(1,:);A3(2,:),A4(2,:)];
sysCL=ss(A_cl,[0;0;0;0],[1 0 0 0],0);
x0=[1 0 1 0]';
[y1 t X1]=initial(sysCL,x0,t);
plot(t,y1,'r');grid;
legend('Output with no observer','Output with observer');
hold off;
figure(2)
plot(t,X1(:,3),t,X1(:,4));grid;
legend('xtidle_1','xtidle_2')