clc
clear all;
close all;
disp('Refer Example 2.17');
%Digital Implementation of Analog Design
%Approximation of Sampled-data system
Ts=0.04;
den=conv(conv([0.5 1],[0.1 1]),[0.05 1]);
G=tf(10,den,'InputDelay',Ts/2);
G1=pade(G,2);
%Analog Design
figure(1);
D=tf([0.67 1],[2 1]);
margin(D*G1)
figure(2);
%GUI functions are available
%in figure window. Zoom in region of -3dB
%contour & read bandwidth.
Gc=D*G1;
nichols(Gc);axis([0 360 -20 20]);
ngrid;
%Discretization of Design
figure(3)
Dz=c2d(D,Ts,'tustin')
G0=tf(10,den);
Gz=c2d(G0,Ts);
Mz=feedback(Dz*Gz,1);
step(Mz);