% This file is required for ScriptPA11
function xpdot = pendulum1(t,x0)
global A b c k
global  m l g a Fc 

xp = x0;
u = -k*xp;

b1 = 4*l/3 - m*a*l*(cos(xp(1)))^2;
c1 = g*sin(xp(1));
c2 = -(m*a*l*sin(2*xp(1))*xp(2)^2)/2;
c3 = a*cos(xp(1))*(Fc - u);

xpdot(1,1) = xp(2);
xpdot(2,1) = (c1 + c2 + c3)/b1;

c4 = 4*l*a*(u - Fc)/3;
c5 = a*sin(xp(1))*(xp(2))^2;
c6 = -m*a*l*g*sin(2*xp(1))/2;

xpdot(3,1) = xp(4,1);
xpdot(4,1) = (c4 + c5 + c6)/b1;